#!/usr/bin/env python
# -*- coding:Utf-8 -*-

# Authors: Fabrice MOURRON <fab@revhosts.net>
# Contributors: Nicolas GREGOIRE <nicob@nicob.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

import re, os, sys, urllib, urllib2


# Regex for matching urls
result = re.compile('[A-Z][.][A-Z].')
secpng = re.compile('.*sec.php*')
invalidKey = re.compile('>INVALID KEY ENTERED<')

webinfo = "http://whois.webhosting.info/"

# return tuple
webhosting = []

if sys.platform == "win32":
	_GOCR = "gocr.exe"
else:
	_GOCR = "gocr"

# function for http request
def request_url(ip_address, verbose):
	if verbose :
		print "Plugin [webhosting] in action  . . ."
	# concatenate url and ip address
	webinfoURL = webinfo + ip_address
	
	# request HTTP
	urllib2.socket.timeout(3)
	u = urllib2.urlopen(webinfoURL)
	

	# return and format urls
	r_urls = extract_urls(u, webinfoURL, verbose)
	for r_url in r_urls:
		webhosting.append(r_url)

	if verbose:
		print "Plugin [webhosting] return . . . . . [found %s result(s)]" % len(webhosting)
	
	return webhosting	# return tuple webhosting[] to main()


# extract and grabs urls, return urls tuple
def extract_urls(u, site, verbose):
	urls = []
	for line in u.readlines():
		if (result.findall(line)):
			urls.append( format_urls(line) )
			
		# if the line contain the return protection form
		elif (secpng.match(line)):
			lien = re.findall('<img src=\'(.*?)\'>',line)
			enck = re.findall('name=\'enck\' value=\'(.*?)\'',line)
			srch_value = re.findall('name=\'srch_value\' value=\'(.*?)\'',line)
			code = grab_png(lien[0])
			if verbose :
				sys.stdout.write('PROTECTION DETECTED\n') # => passage
			params = { "enck": enck[0], "srch_value":srch_value[0],"code": code, "subSecurity": "Submit" }
			encoded_params = urllib.urlencode(params)
			pngRequest = urllib2.Request(site, encoded_params)
			p = urllib2.urlopen(pngRequest)
			for pngLine in p.readlines():
				if (result.findall(pngLine)):
					urls.append( format_urls(pngLine) )
				elif (invalidKey.findall(pngLine)):
					print code + " : Invalid Key"
	u.close()
	return urls


# format VirtualHost
def format_urls(line):
	line = re.sub('<.*?>|&nbsp','',line)
	line = re.sub('.\r\n','',line)
	urls = line.lower()
	return urls


# Bufferize the png in sec.png file and maybe return the result \o/
def grab_png(url):
	pngFile = open('sec.png', 'a')
	reqPng = urllib2.urlopen(url)
	for linePng in reqPng.readlines():
		pngFile.write(linePng)
	pngFile.close()
	ret =os.system(_GOCR + " sec.png" + " -o c0de") 
	if ret != 0:
		print "\nError running OCR. Make sure you have gocr installed.\n"
		sys.exit(0)
	codeOcr = open('c0de','r')
	code = codeOcr.read(5)	# Only the first five numbers
	codeOcr.close()
	code.strip()		# strip spaces before and after string
	os.remove('sec.png')
	os.remove('c0de')
	return code		# return code
