#!/usr/bin/env python
# -*- coding:Utf-8 -*-

# AUthor: Nicolas GREGOIRE <nicob@nicob.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

from OpenSSL import SSL
import sys, os, select, socket, threading, time, timeoutsocket
from threading import Thread

#timeoutsocket.setDefaultSocketTimeout(1)

# Return tuple
ssl_cname = []

# Debug messages (boolean)
debug = 0

# DESACTIVATE PLUGIN
desactive = 0

# Services to scan
# https             443/tcp    # secure http (SSL)
# smtps             465/tcp    # smtp protocol over TLS/SSL (was ssmtp)
# nntps             563/tcp    # NNTP over SSL
# imap4-ssl         585/tcp    # IMAP4+SSL (use of 585 is not recommended,
# ldapssl           636/tcp    # LDAP over SSL
# ftps              990/tcp    # ftp protocol, control, over TLS/SSL
# telnets           992/tcp    # telnet protocol over TLS/SSL
# imaps             993/tcp    # imap4 protocol over TLS/SSL
# ircs              994/tcp    # irc protocol over TLS/SSL
# pop3s             995/tcp    # POP3 protocol over TLS/SSL
ports = ["443","465","563","585","636","990","992","993","994","995"]

class Knock(Thread):
    """Knock, knock, knocking on heaven's port ;-)"""
    def __init__(self, host, port, verbose):
        Thread.__init__(self)
        self.host = host
        self.port = port
        self.verbose = verbose
        
    def run(self):
        ssl_connect(self.host, self.port, self.verbose)
        if debug :
           #print "Debug Knock host:", self.host
            print "Debug Knock port:", self.port
            
    def shutdown(self):
        """Stop this thread"""
        self.__stop()
        
# main() of the plugin
def request_url(host, verbose):
    
    if desactive :
        return ssl_cname
        return 0
    
    if verbose :
        print "Plugin [SSL CNAME] in action . . . ."
          
    for port in ports:
        knock = Knock(host, port, verbose)
        knock.start()
        knock.join()

    if verbose:
        print "Plugin [SSL CNAME] return  . . . . . [%s result(s)]" % len(ssl_cname)
           
    return ssl_cname    # return tuple ssl_cname[] to main()


# Function to extract information from the SSL certificate
def extract_cname(conn, cert, errnum, depth, ok):
        subject = cert.get_subject()
        ssl_cname.append(subject.commonName)
        if debug:
                print 'CName: "%s"' % subject.commonName
                print '%s' % subject
                if cert.has_expired():
                        print 'Cert has expired'
        return ok

# Function to connect to a SSL port and fetch the certificate
def ssl_connect(dst_host, dst_port, verbose):
        # Debug
        if debug:
                print 'Target port : %s' % dst_port

        # Create SSL context
        ctx = SSL.Context(SSL.SSLv23_METHOD)
        ctx.set_verify(SSL.VERIFY_PEER, extract_cname)

        # Create socket
        sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        
        #sock.set_timeout(0.1)
        # Create SSL connection
        conn = SSL.Connection(ctx, sock)
        try:
            conn.connect((dst_host, int(dst_port)))
        except(timeoutsocket.Timeout, timeoutsocket.Error):
            if verbose :
                print "Timed out talking to %s:%s, continue !" % (dst_host, dst_port)
            else :
                pass
#        except socket.error:
#                conn.close()
            return 1

        # Read from the socket
        try:
                sys.stdout.write(conn.recv(1024))
                sys.stdout.flush()
        except SSL.Error:
                conn.shutdown()
                conn.close()
                return 1

        return 1
        