#!/usr/bin/env python
# -*- coding:Utf-8 -*-

# Authors: Fabrice MOURRON <fab@revhosts.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

import os, sys, re, socket

#from socket import gethostbyname

def loadPlugins (directory):
	ls = os.listdir(directory)
	Plugins = []
	rege = re.compile('(?!timeoutsocket)[^\.|_].*[.]py$')
	ext = re.compile('[^\.|_].*')
	for names in ls:
		if rege.match(names):
			new = os.path.splitext(names)
			for plugin in new:
				if ext.match(plugin):
					Plugins.append(plugin)
	return Plugins


def unique(s):
	n = len(s)
	if n == 0:
		return []
	u = {}
	try:
		for x in s:
			u[x] = 1
	except TypeError:
		del u  # move on to the next method
	else:
		return u.keys()

	try:
		t = list(s)
		t.sort()
	except TypeError:
		del t  # move on to the next method
	else:
		assert n > 0
		last = t[0]
		lasti = i = 1
		while i < n:
			if t[i] != last:
				t[lasti] = last = t[i]
				lasti += 1
			i += 1
		return t[:lasti]

    # Brute force is all that's left.
	u = []
	for x in s:
		if x not in u:
			u.append(x)
	return u

def verify(url):
	"This function resolve the URL and return the ip_adress"
	try:
		ip = socket.gethostbyname(url)
	except socket.error :
		ip = None
	return ip

def getUrls(dicoUrls, ip_address, verbose):
	"This function verify, hash and sort urls and return a tuple"
	if verbose:
		print "Verify, Hash and Sort in action  . .\r\n"
	# Tuple for formatting results
	urlsTmp = []
	urlsVerify = []
	urlsMove = []
	urlsUniq = []
	for clef, valeur in dicoUrls.items():
		for url in valeur:
			urlsTmp.append(url)
		# urlUniq = [host for host in urlTmp if host not in locals()['_[1]']]
		# or for python < 2.4
		# urlUniq = [host for host in urlTmp if host not in locals().__self__]
		#print urlUniq
	urlsVerify = unique(urlsTmp)
	
	for url in urlsVerify:
		ipResolv = verify(url)
		if ipResolv != ip_address :
			urlsMove.append(url)
		else :
			urlsUniq.append(url)
	return urlsUniq
