#!/usr/bin/env python
# -*- coding:Utf-8 -*-

# Authors:       Fabrice MOURRON <fab@revhosts.net>

# Contributors:  Nicolas GREGOIRE <nicob@nicob.net>
#                David MACIEJAK <david.maciejak@gmail.com>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

__author__ = "Fabrice MOURRON <fab@revhosts.net>"
__copyright__ = "Copyright (c) 2005-2006 Fabrice MOURRON"
__license__ = "GPL"
__version__ = "1.1_fab"
__cvsversion__ = "73: $"
__date__ = "$Date: $"


import re, sys, threading, socket
from threading import Thread

sys.path.insert(0, 'Plugins/')
sys.path.insert(0, 'Plugins_Evil/')
sys.path.insert(0, 'lib/')

# Librairies
from lib import revhostslib
#import timeoutsocket

# For parse arguments
import optparse

# Set timeoutsocket
#timeoutsocket.setDefaultSocketTimeout(2)

# Plugins name in an array
pluginsList = revhostslib.loadPlugins('Plugins')
tempArray = []
index = 0
while index < len(pluginsList):
    tempArray.append(__import__(pluginsList[index]))
    index = index + 1


# Dico for storing plugins results
urlsMain = {}

class OptionParser (optparse.OptionParser):

    def check_required (self, opt):
      option = self.get_option(opt)

      # Assumes the option's 'default' is set to None!
      if getattr(self.values, option.dest) is None:
          self.error("%s option ip_adress or host required, type -h for help" % option)

class Launch(Thread):
    """Construct Launch plugin in a thread"""
    def __init__(self, tempArray, module, ip_address, verbose):
        Thread.__init__(self)
        self.tempArray = tempArray
        self.module = module
        self.ip_address = ip_address
        self.verbose = verbose
    def run(self):
        #"""Launch plugin in a thread """            
        self.content = self.tempArray[self.module].request_url(self.ip_address, self.verbose)        

def startThread(tempArray, ip_address, verbose, output):
    module = 0    
        
    while module < len(tempArray) :
        plugin = Launch(tempArray, module, ip_address, verbose)
        plugin.start()
        plugin.join()
        urlsMain[pluginsList[module]] = plugin.content
        module = module + 1
                
    if output:
        urlFile = open(output,'a')
        retUrls = revhostslib.getUrls(urlsMain, ip_address, verbose)
        retUrls.sort()
        for retUrlsUniq in retUrls:
            urlFile.write(retUrlsUniq + "\n")
            print retUrlsUniq
            
    else:
        retUrls = revhostslib.getUrls(urlsMain, ip_address, verbose)
        retUrls.sort()
        for retUrlsUniq in retUrls:
            print retUrlsUniq

    if verbose:
        print "\r"
        print "-----------------------------------------------"
        print "Found %s VirtualHost(s) on %s address" % ( len(retUrls), (ip_address) )
        print "-----------------------------------------------"

# __main__
def main():
    usage ="usage: %prog <target> [options]"
    parser = OptionParser(usage)
    
    parser.add_option("-e", "--evil", action="store_true",
                       dest="evil", help="active evils plugins")
    parser.add_option("-v", "--verbose", action="store_true", 
                       dest="verbose", help="show more details")
    parser.add_option("-o", "--out", type="string", 
                       dest="file", help="output result in FILE")
                       
    ( options, args ) = parser.parse_args()
    
    # check the args first if it's an ip address
    ip_matcher = re.compile( '\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}' )
    fqdn_matcher = re.compile( '^[\w\.-]+$' )
	
    # if not an ip address or if ip_address is not valid, exit
    if not ip_matcher.match( sys.argv[1] ):
        	#test if we have a fqdn
        	if fqdn_matcher.match( sys.argv[1] ):
            		try:
                		sys.argv[1] = socket.gethostbyname( sys.argv[1] )
            		except socket.error:
                		parser.error( "fqdn %s could not be resolved" % sys.argv[1] )
        	else:            
		    parser.error( "incorrect number of arguments %s" % sys.argv[1] )

    if options.evil:
		# Plugins name in an array
    		pluginsEvilList = revhostslib.loadPlugins( 'Plugins_Evil' )
            	global pluginsList
    		pluginsList = pluginsList + pluginsEvilList
    		indexEvil = 0
    		while indexEvil < len( pluginsEvilList ):
        		tempArray.append( __import__( pluginsEvilList[indexEvil] ) )
        		indexEvil = indexEvil + 1    
    
    threadMain = threading.Thread( target=startThread, 
                                   args=( tempArray, sys.argv[1], options.verbose, options.file ) )
    threadMain.start()

if __name__ == "__main__":
    sys.exit(main())

